function DeIM=Decode_Color_Image_DWT_DCT(Load_Path)
% This fucntion is used for Decompress Color image  (CIC2011)
% Decompression algorithm for (CIC2011)
% This function is represcompression algorithm
% Desinged by : Mohammed Mustafa Siddeq
% Date 28-Nov.- 2011
%-------------------------------------------------------------------------
% INPUT \
%     Load_Path    :-  path for load compressed image data type CIC2011
%     Wavelet_Name :- wavelet family name

% OUTPUT \ the output of this function is "DeIM" Decompressed RGB color image
%-------------------------------------------------------------------------
% Example - Compelet program for color image compression / decompression 
%    Im = imread('D:\image11.bmp');
%    Quantize=[0.01, 0.1, 0.1];
%    CompressedData=Code_Color_DWT_DCT(Im,Quantize,'c:\comp.CIC','db5'); --> Compression

%    De=Decode_Color_Image_DWT_DCT('c:\comp.CIC'); --> Decompression
%    imshow(De); 
%-------------------------------------------------------------------------





% See the coding function :- "Code_Color_Image_DWT_DCT.m"

% ------------------------------------------------------------------------

Header=load(Load_Path, '-mat');
ColorData=Header.ColorData;

Y1=ColorData.Y1;
Cb=ColorData.Cb;
Cr=ColorData.Cr;

PicY=Decode_Image_DWT_DCT('',Y1,'Read');
Piccb=Decode_Image_DWT_DCT('',Cb,'Read');
Piccr=Decode_Image_DWT_DCT('',Cr,'Read');
YC(:,:,1)=PicY(:,:);
YC(:,:,2)=Piccb(:,:);
YC(:,:,3)=Piccr(:,:);

DeIM = ycbcr2rgb(YC);
%imshow(uint8(DeIM));
end 
