function Pic=Decode_Image_DWT_DCT(Load_Path,H,Check)
% Gray Image Deompression Program by Wavelet Transform and Cosine Transform
%  
% the INPUT\
%                 
%    Load_Path :- path for load compressed image file (i.e. Header) 
%    H         :- Header information for compressed image file...
%    Check     :- this paramenter is check if you need to 'Load' or 'Read'   
%                  'Load' --> load from compressed file
%                  'Read' --> read from coded "H"                  
%The OUTPUT \ the output is "Pic" is show you the Decoded image 

%-----------Example 1------------------------------------------------------
%    Example :- for compress and decompress an gray level image 
%     Im = imread('D:\lectures\images\big3.bmp');
%     Image_code_DWT_DCT(Im,0.1,'D:\mm\code.IC','db5'); --> Compress
%     P=Deode_Image_DWT_DCT('D:\mm\code.IC',0,'Load');  ------> Decompress
%     imshow(P);
%-----------Example 2 -----------------------------------------------------
%     Im = imread('D:\lectures\images\big3.bmp');
%     Header=Image_code_DWT_DCT(Im,0.1,'','db5');
%     P=Deode_Image_DWT_DCT('',Header,'Read');
%     imshow(P);        

% See the function : " Image_code_DWT_DCT "


% this program designed by  ---------- Mohammed M. Siddeq
% date :- 26/11/2011

%-----------------Load Compressed data from a file ------------------------------------------
if (Check=='Load')
 Header=load(Load_Path, '-mat');
 H=0;
 H=Header.H;
end;
n=16;
% -----------------------Read infomation about compressed image:
Wave_Name=H(34).Wave_Name;
Size_A=H(33).Size_A;
S_1=H(31).S_1;
S_2=H(32).S_2;
M3=H(1).M3;
M2=H(2).M2;
MLL3=H(3).MLL3;
POSHH3=H(25).POSHH3; POSHL3=H(26).POSHL3; POSLH3=H(27).POSLH3;
POSHH2=H(28).POSHH2; POSHL2=H(29).POSHL2; POSLH2=H(30).POSLH2;

%%%%%%%%%%%%%%%%%% Decompress the Header information
Code_Array=H(22).Code_Array; H1_Array=H(23).H1_Array; H2_Array=H(24).H2_Array;
Array=Arith_Decode(Code_Array,H1_Array,H2_Array);

Code_LH2=H(19).Code_LH2; H1_LH2=H(20).H1_LH2; H2_LH2=H(21).H2_LH2;
nonzeroLH2=Arith_Decode(Code_LH2,H1_LH2,H2_LH2);

Code_HL2=H(16).Code_HL2; H1_HL2=H(17).H1_HL2; H2_HL2=H(18).H2_HL2;

nonzeroHL2=Arith_Decode(Code_HL2,H1_HL2,H2_HL2);

nonzeroHH2=Arith_Decode(H(13).Code_HH2,H(14).H1_HH2,H(15).H2_HH2);

nonzeroLH3=Arith_Decode(H(10).Code_LH3,H(11).H1_LH3,H(12).H2_LH3);

nonzeroHL3=Arith_Decode(H(7).Code_HL3,H(8).H1_HL3,H(9).H2_HL3);

nonzeroHH3=Arith_Decode(H(4).Code_HH3,H(5).H1_HH3,H(6).H2_HH3);

%%%%% ------------- using Decoded sub-bands -------------------------------
HH3=Return_Zeros_Matrix(S_1,nonzeroHH3,POSHH3,n);
HL3=Return_Zeros_Matrix(S_1,nonzeroHL3,POSHL3,n);
LH3=Return_Zeros_Matrix(S_1,nonzeroLH3,POSLH3,n);

HL2=Return_Zeros_Matrix(S_2,nonzeroHL2,POSHL2,n);
LH2=Return_Zeros_Matrix(S_2,nonzeroLH2,POSLH2,n);
HH2=Return_Zeros_Matrix(S_2,nonzeroHH2,POSHH2,n);
LL3=Decode_T_Matrix(Array,Size_A,MLL3);


%------------- Reconstruction (Inverse Transformation) -------------------
LL3=round(LL3.*2); LH3=round(LH3*M3); HL3=round(HL3*M3); HH3=round(HH3*M3);
newLL3(1:S_1(1),1:S_1(2))=LL3(1:S_1(1),1:S_1(2));
LL2=idwt2(newLL3,HL3,LH3,HH3,Wave_Name);

LL2=round(LL2.*2); LH2=round(LH2*M2); HL2=round(HL2*M2); HH2=round(HH2*M2);
newLL2(1:S_2(1),1:S_2(2))=LL2(1:S_2(1),1:S_2(2));
LL=idwt2(newLL2,HL2,LH2,HH2,Wave_Name);

LL=round(LL.*2);
LH=0; S_=size(LL); LH(1:S_(1),1:S_(2))=0;
% Decompressed image...........
Pic=idwt2(LL,LH,LH,LH,Wave_Name);
Pic=uint8(Pic);
'Deompression .... OK'
end