function H=Image_code_DWT_DCT(Im,Factor,Save_Path,Wave_Name)
% Gray Image Compression Program by Wavelet Transform and Cosine Transform
% This function compress the image matrix "Im" 

% the INPUT \
%    Im       :- Input image for compress
%    Factor   :- This factor is used to reduce high-Frequency image quality  
%              (defualt )factor range = [0.01 - 0.1] 
%               IF Factor >= 0.1 , the decode image will be degraded (blurred)  
%                
%    Save_Path :- path for save compressed image (i.e. Header) 
%    Wave_Name :- Wavelet name (i.e. db3, db4,... etc)

%the OUTPUT \ the output is "H" is show you the information for the compressed
%      header file contains important data with compressed data 
%
%-- Example 1 -------------------------------
%    Example :- to compress an gray level image 
%   Im = imread('D:\lectures\images\big3.bmp');
%   Header=Image_code_DWT_DCT(Im,0.05,'D:\mm\code.CIC','db3');

%-- Example 2 -------------------------------
%   Im = imread('D:\lectures\images\big3.bmp');
%   Header=Image_code_DWT_DCT(Im,0.05,'','db3');

% See the functcion : " Decode_Image_DWT_DCT " 

% this program designed by  ---------- Mohammed M. Siddeq
% date :- 26/11/2011
%-------------------------------------------------------------------------

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Factor2=0.01; %This Value is constant for all type of image........  
%%%%%%%%%%%%% this value represents 1% from maximum value to be divided by 
%             low-freqeuncy "LL3" , 
%             range of Factor2 =[0.005 - 0.01], defualt value is "0.01". 



n=16; % this block size used for search inside a matrix for nonzero data


[LL,HL,LH,HH]=dwt2(Im,Wave_Name);
LL=round(LL./2);  %%% all sub-bands are zeros


[LL2,HL2,LH2,HH2]=dwt2(LL,Wave_Name);
LL2=round(LL2./2); M2=max(LH2(:))*Factor; S_2=size(LH2);
LH2=round(LH2/M2); HL2=round(HL2/M2); HH2=round(HH2/M2);

[LL3,HL3,LH3,HH3]=dwt2(LL2,Wave_Name);
LL3=round(LL3./2);M3=max(LH3(:))*Factor; S_1=size(LH3);
LH3=round(LH3/M3); HL3=round(HL3/M3); HH3=round(HH3/M3);

 MLL3=max(LL3(:))*Factor2;
[Array,Size_A]=Code_T_Matrix(LL3,MLL3);
%----------------- End of Transformation --------



%%% Compress each sub-band for Level two...
[nonzeroHL2,POSHL2]=Eliminate_Zeros_Matrix(HL2,n);
[nonzeroLH2,POSLH2]=Eliminate_Zeros_Matrix(LH2,n);
[nonzeroHH2,POSHH2]=Eliminate_Zeros_Matrix(HH2,n); 


%%% Compress each sub-band for Level Three...
[nonzeroHL3,POSHL3]=Eliminate_Zeros_Matrix(HL3,n); 
[nonzeroLH3,POSLH3]=Eliminate_Zeros_Matrix(LH3,n); 
[nonzeroHH3,POSHH3]=Eliminate_Zeros_Matrix(HH3,n);
%---------------------------------END ------------------------------------


% ---LEVEL 3--------Coding all information and Store all data in a file.........
if (max(nonzeroHH3(:))==0 && min(nonzeroHH3(:))==0)
    Code_HH3=0; H1_HH3=0;H2_HH3=0; 
else
[Code_HH3,H1_HH3,H2_HH3]=Arith_Code(nonzeroHH3);
end;
Code_HH3=uint8(Code_HH3); H1_HH3=int16(H1_HH3);H2_HH3=int16(H2_HH3); if (max(POSHH3(:))>255) POSHH3=uint16(POSHH3); else POSHH3=uint8(POSHH3); end;

if (max(nonzeroHL3(:))==0 && min(nonzeroHL3(:))==0)
    Code_HL3=0; H1_HL3=0;H2_HL3=0; 
else
[Code_HL3,H1_HL3,H2_HL3]=Arith_Code(nonzeroHL3);
end;
Code_HL3=uint8(Code_HL3); H1_HL3=int16(H1_HL3);H2_HL3=int16(H2_HL3); if (max(POSHL3(:))>255) POSHL3=uint16(POSHL3); else POSHL3=uint8(POSHL3); end;

if (max(nonzeroLH3(:))==0 && min(nonzeroLH3(:))==0)
    Code_LH3=0; H1_LH3=0;H2_LH3=0; 
else
[Code_LH3,H1_LH3,H2_LH3]=Arith_Code(nonzeroLH3);
end;
Code_LH3=uint8(Code_LH3); H1_LH3=int16(H1_LH3);H2_LH3=int16(H2_LH3); if (max(POSLH3(:))>255) POSLH3=uint16(POSLH3); else POSLH3=uint8(POSLH3); end;


%--- LEVEL 2 ----------------------------------------------------------
if (max(nonzeroHH2(:))==0 && min(nonzeroHH2(:))==0)
    Code_HH2=0; H1_HH2=0;H2_HH2=0; 
else
[Code_HH2,H1_HH2,H2_HH2]=Arith_Code(nonzeroHH2);
end;
Code_HH2=uint8(Code_HH2); H1_HH2=int16(H1_HH2);H2_HH2=int16(H2_HH2); if (max(POSHH2(:))>255) POSHH2=uint16(POSHH2); else POSHH2=uint8(POSHH2); end;

if (max(nonzeroHL2(:))==0 && min(nonzeroHL2(:))==0)
    Code_HL2=0; H1_HL2=0;H2_HL2=0; 
else
[Code_HL2,H1_HL2,H2_HL2]=Arith_Code(nonzeroHL2);
end;
Code_HL2=uint8(Code_HL2); H1_HL2=int16(H1_HL2);H2_HL2=int16(H2_HL2); if (max(POSHL2(:))>255) POSHL2=uint16(POSHL2); else POSHL2=uint8(POSHL2); end;

if (max(nonzeroLH2(:))==0 && min(nonzeroLH2(:))==0)
    Code_LH2=0; H1_LH2=0;H2_LH2=0;
else
[Code_LH2,H1_LH2,H2_LH2]=Arith_Code(nonzeroLH2);
end;
Code_LH2=uint8(Code_LH2); H1_LH2=int16(H1_LH2);H2_LH2=int16(H2_LH2); if (max(POSLH2(:))>255) POSLH2=uint16(POSLH2); else POSLH2=uint8(POSLH2); end;
%---Coding Low-Frequency LL3-------------------------------------------------------------
[Code_Array,H1_Array,H2_Array]=Arith_Code(Array);
Code_Array=uint8(Code_Array); H1_Array=int16(H1_Array); H2_Array=int16(H2_Array);  




%( H E A D E R     F I L E )-------------------------------------------
%Parameters are used for Decompression
%%% ------------------ Save Header information and Compressed Data in a file
H(1).M3=M3;   
H(2).M2=M2;
H(3).MLL3=MLL3;
H(4).Code_HH3=Code_HH3; H(5).H1_HH3=H1_HH3; H(6).H2_HH3=H2_HH3;
H(7).Code_HL3=Code_HL3; H(8).H1_HL3=H1_HL3; H(9).H2_HL3=H2_HL3;
H(10).Code_LH3=Code_LH3; H(11).H1_LH3=H1_LH3;H(12).H2_LH3=H2_LH3;
H(13).Code_HH2=Code_HH2; H(14).H1_HH2=H1_HH2; H(15).H2_HH2=H2_HH2;
H(16).Code_HL2=Code_HL2; H(17).H1_HL2=H1_HL2; H(18).H2_HL2=H2_HL2;
H(19).Code_LH2=Code_LH2; H(20).H1_LH2=H1_LH2; H(21).H2_LH2=H2_LH2;
H(22).Code_Array=Code_Array; H(23).H1_Array=H1_Array; H(24).H2_Array=H2_Array;
H(25).POSHH3=POSHH3; H(26).POSHL3=POSHL3; H(27).POSLH3=POSLH3;
H(28).POSHH2=POSHH2; H(29).POSHL2=POSHL2; H(30).POSLH2=POSLH2;
H(31).S_1=uint16(S_1);
H(32).S_2=uint16(S_2);
H(33).Size_A=uint16(Size_A);
H(34).Wave_Name=Wave_Name;
%---------------------------Save it in a file------------------------------
save(Save_Path, 'H');
'Finished  Compression .... OK'
end
